/*
  Copyright (c) 2013, Matthias Schiffer <mschiffer@universe-factory.net>
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/


#ifndef _GMRF_MMSS_MMSS_H_
#define _GMRF_MMSS_MMSS_H_

#include <gmrf/gmrf.h>


typedef struct mmss_context mmss_context_t;
typedef struct mmss_node mmss_node_t;
typedef struct mmss_network mmss_network_t;


struct mmss_context {
	uint64_t now;
};

struct mmss_node {
	mmss_node_t *next;

	gmrf_iface_t *interfaces;
};

struct mmss_network {
	mmss_network_t *next;

	gmrf_iface_t *interfaces;

	size_t mtu;
};


struct gmrf_iface {
	gmrf_iface_t *node_next;
	gmrf_iface_t *network_next;

	mmss_node_t *node;
	mmss_network_t *net;

	gmrf_addr_t address;
};

struct gmrf_context {
	mmss_context_t *mmss;
	mmss_node_t *node;
};


#endif /* _GMRF_MMSS_MMSS_H_ */
